//
// Example usage of grey artistic filters
// Bala Amavasai (bala@amavasai.org)
//
//

// $Header: /cvs/mimas2/examples/artistic/main.cc,v 1.1.1.1 2005/08/09 15:37:41 engmb Exp $


#include <fstream>
#include <iostream>
#include "image.h"
#include "image_fileinput.h"
#include "image_mesaoutput.h"
#include "image_funcs.h"

using namespace mimas;
using namespace std;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {
    image<int> imagein, imageout;
    
    x11_display display;
    image_mesaoutput<unsigned char> win( &display );

    const char *fileName = "../images/stills/lena-512x512.pgm";
    ifstream file( fileName, ios::binary );
    MMERROR( file >> imagein, mimasexception, ,
             "Error loading file \"" << fileName << "\"." );

    win << imagein << mimas::pause();

    oilPainting(imagein,imageout,7);
    win << imageout << mimas::pause();

    win << focusEnhance( imagein ) << mimas::pause();

    win << featureEnhance( imagein ) << mimas::pause();

    win << emboss( imagein ) << mimas::pause();

    win << softenHeavy( imagein ) << mimas::pause();

    win << softenMedium( imagein ) << mimas::pause();

    win << softenLight( imagein ) << mimas::pause();
  } catch ( exception &e ) {
    cerr << "Error: " << e.what() << endl;
    retVal = 1;
  };

  return retVal;
}
