#ifndef CALIBRATION_H
#define CALIBRATION_H

#include <QtCore/QTimer>
#include <QtCore/QList>
#include <QtGui/QDialog>
#include <QtGui/QMessageBox>
#include "image_v4linput.h"
#include "mimasexception.h"
#include "camera.h"
#include <iomanip>
#include <iostream>

#include "ui_calibration.h"
#include "picture.h"
#include "config.h"

#define CORNER 0
#define BLACK  1
#define WHITE  2

typedef rgba< unsigned char > pixel;

using namespace mimas;
using namespace camera_calibration;
using namespace std;

class Calibration : public QDialog, Ui::Dialog {

  Q_OBJECT

private:
  QList< Picture > list;

  QTimer *timer;

  int size_x,
    size_y,
    size_window,
    preview,
    colour;
  
  double min_corr;

  string device;

public:
  Calibration(int size_x, int size_y, int size_window, double min_corr, 
	      char *device, int preview);

public slots:
  void refresh_image();
  void takePicture();
  void removePicture(); 
  void clicCorners();
  void findCorners();
  void calibrate();
  void changeImage(int current);
  void takeColours();

};

#endif
