#ifndef DISPLAY_H
#define DISPLAY_H

#include <QtGui/QLabel>
#include <QtGui/QtGui>
#include <QtGui/QPixmap>
#include <QtGui/QPaintEvent>
#include <QtGui/QPainter>
#include <QtGui/QMessageBox>

#include "corner_detection.h"

#include "picture.h"

#define CORNER 0
#define BLACK  1
#define WHITE  2

typedef rgba< unsigned char > pixel_rgba;

class Calibration;

class DisplayPicture : public QLabel {
  
public :
  DisplayPicture(QWidget *parent = 0, Qt::WFlags f = 0);

  void setImage(Picture *p);

  inline void setDisplayPresent(bool set) { isPict = set; }
  inline bool getDisplayPresent(){ return isPict; }

  void resetCorners(); 
  void findCorners(int size_x, int size_y, int size_window, double min_corr) throw (mimasexception);

  void click(int n);

protected:
  void mousePressEvent(QMouseEvent *event);
  void paintEvent(QPaintEvent *event);

private:
  bool isPict;
  Picture *pict;
  int action;
  pixel_rgba black_pixel, white_pixel;

};

#endif
