#ifndef UI_CALIBRATION_H
#define UI_CALIBRATION_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QFrame>
#include <QtGui/QGridLayout>
#include <QtGui/QHBoxLayout>
#include <QtGui/QLabel>
#include <QtGui/QListWidget>
#include <QtGui/QPushButton>
#include <QtGui/QSpacerItem>
#include <QtGui/QVBoxLayout>
#include "displaypicture.h"

class Ui_Dialog
{
public:
    QVBoxLayout *vboxLayout;
    QFrame *frame;
    QHBoxLayout *hboxLayout;
    QFrame *frame_2;
    QVBoxLayout *vboxLayout1;
    QListWidget *listWidget;
    QPushButton *btAdd;
    QPushButton *btRemove;
    QPushButton *btCalib;
    QFrame *frame_5;
    QGridLayout *gridLayout;
    QLabel *video_image;
    QFrame *frame_3;
    QVBoxLayout *vboxLayout2;
    QFrame *frame_4;
    QHBoxLayout *hboxLayout1;
    DisplayPicture *lbImage;
    QHBoxLayout *hboxLayout2;
    QPushButton *btColours;
    QPushButton *btClick;
    QPushButton *btCorners;
    QSpacerItem *spacerItem;
    QHBoxLayout *hboxLayout3;
    QLabel *lbNotes;
    QSpacerItem *spacerItem1;
    QPushButton *okButton;

    void setupUi(QDialog *Dialog)
    {
    Dialog->setObjectName(QString::fromUtf8("Dialog"));
    Dialog->resize(QSize(519, 479).expandedTo(Dialog->minimumSizeHint()));
    vboxLayout = new QVBoxLayout(Dialog);
    vboxLayout->setSpacing(6);
    vboxLayout->setMargin(8);
    vboxLayout->setObjectName(QString::fromUtf8("vboxLayout"));
    frame = new QFrame(Dialog);
    frame->setObjectName(QString::fromUtf8("frame"));
    frame->setFrameShape(QFrame::StyledPanel);
    frame->setFrameShadow(QFrame::Raised);
    hboxLayout = new QHBoxLayout(frame);
    hboxLayout->setSpacing(6);
    hboxLayout->setMargin(8);
    hboxLayout->setObjectName(QString::fromUtf8("hboxLayout"));
    frame_2 = new QFrame(frame);
    frame_2->setObjectName(QString::fromUtf8("frame_2"));
    frame_2->setFrameShape(QFrame::StyledPanel);
    frame_2->setFrameShadow(QFrame::Raised);
    vboxLayout1 = new QVBoxLayout(frame_2);
    vboxLayout1->setSpacing(6);
    vboxLayout1->setMargin(8);
    vboxLayout1->setObjectName(QString::fromUtf8("vboxLayout1"));
    listWidget = new QListWidget(frame_2);
    listWidget->setObjectName(QString::fromUtf8("listWidget"));
    listWidget->setMinimumSize(QSize(150, 0));
    listWidget->setMaximumSize(QSize(150, 16777215));

    vboxLayout1->addWidget(listWidget);

    btAdd = new QPushButton(frame_2);
    btAdd->setObjectName(QString::fromUtf8("btAdd"));
    btAdd->setMinimumSize(QSize(150, 0));
    btAdd->setMaximumSize(QSize(150, 16777215));

    vboxLayout1->addWidget(btAdd);

    btRemove = new QPushButton(frame_2);
    btRemove->setObjectName(QString::fromUtf8("btRemove"));
    btRemove->setMinimumSize(QSize(150, 0));
    btRemove->setMaximumSize(QSize(150, 16777215));

    vboxLayout1->addWidget(btRemove);

    btCalib = new QPushButton(frame_2);
    btCalib->setObjectName(QString::fromUtf8("btCalib"));
    btCalib->setMinimumSize(QSize(150, 0));
    btCalib->setMaximumSize(QSize(150, 16777215));

    vboxLayout1->addWidget(btCalib);

    frame_5 = new QFrame(frame_2);
    frame_5->setObjectName(QString::fromUtf8("frame_5"));
    frame_5->setMinimumSize(QSize(16, 16));
    frame_5->setMaximumSize(QSize(150, 16777215));
    frame_5->setFrameShape(QFrame::StyledPanel);
    frame_5->setFrameShadow(QFrame::Raised);
    gridLayout = new QGridLayout(frame_5);
    gridLayout->setSpacing(6);
    gridLayout->setMargin(8);
    gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
    video_image = new QLabel(frame_5);
    video_image->setObjectName(QString::fromUtf8("video_image"));
    video_image->setMinimumSize(QSize(0, 0));

    gridLayout->addWidget(video_image, 0, 0, 1, 1);


    vboxLayout1->addWidget(frame_5);


    hboxLayout->addWidget(frame_2);

    frame_3 = new QFrame(frame);
    frame_3->setObjectName(QString::fromUtf8("frame_3"));
    frame_3->setFrameShape(QFrame::StyledPanel);
    frame_3->setFrameShadow(QFrame::Raised);
    vboxLayout2 = new QVBoxLayout(frame_3);
    vboxLayout2->setSpacing(6);
    vboxLayout2->setMargin(8);
    vboxLayout2->setObjectName(QString::fromUtf8("vboxLayout2"));
    frame_4 = new QFrame(frame_3);
    frame_4->setObjectName(QString::fromUtf8("frame_4"));
    frame_4->setFrameShape(QFrame::StyledPanel);
    frame_4->setFrameShadow(QFrame::Raised);
    hboxLayout1 = new QHBoxLayout(frame_4);
    hboxLayout1->setSpacing(6);
    hboxLayout1->setMargin(8);
    hboxLayout1->setObjectName(QString::fromUtf8("hboxLayout1"));
    lbImage = new DisplayPicture(frame_4);
    lbImage->setObjectName(QString::fromUtf8("lbImage"));

    hboxLayout1->addWidget(lbImage);


    vboxLayout2->addWidget(frame_4);

    hboxLayout2 = new QHBoxLayout();
    hboxLayout2->setSpacing(6);
    hboxLayout2->setMargin(0);
    hboxLayout2->setObjectName(QString::fromUtf8("hboxLayout2"));
    btColours = new QPushButton(frame_3);
    btColours->setObjectName(QString::fromUtf8("btColours"));

    hboxLayout2->addWidget(btColours);

    btClick = new QPushButton(frame_3);
    btClick->setObjectName(QString::fromUtf8("btClick"));

    hboxLayout2->addWidget(btClick);

    btCorners = new QPushButton(frame_3);
    btCorners->setObjectName(QString::fromUtf8("btCorners"));

    hboxLayout2->addWidget(btCorners);

    spacerItem = new QSpacerItem(40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);

    hboxLayout2->addItem(spacerItem);


    vboxLayout2->addLayout(hboxLayout2);


    hboxLayout->addWidget(frame_3);


    vboxLayout->addWidget(frame);

    hboxLayout3 = new QHBoxLayout();
    hboxLayout3->setSpacing(6);
    hboxLayout3->setMargin(0);
    hboxLayout3->setObjectName(QString::fromUtf8("hboxLayout3"));
    lbNotes = new QLabel(Dialog);
    lbNotes->setObjectName(QString::fromUtf8("lbNotes"));

    hboxLayout3->addWidget(lbNotes);

    spacerItem1 = new QSpacerItem(131, 31, QSizePolicy::Expanding, QSizePolicy::Minimum);

    hboxLayout3->addItem(spacerItem1);

    okButton = new QPushButton(Dialog);
    okButton->setObjectName(QString::fromUtf8("okButton"));

    hboxLayout3->addWidget(okButton);


    vboxLayout->addLayout(hboxLayout3);

    retranslateUi(Dialog);
    QObject::connect(okButton, SIGNAL(clicked()), Dialog, SLOT(accept()));

    QMetaObject::connectSlotsByName(Dialog);
    } // setupUi

    void retranslateUi(QDialog *Dialog)
    {
    Dialog->setWindowTitle(QApplication::translate("Dialog", "Mimas Camera Calibration Tool"));
    btAdd->setText(QApplication::translate("Dialog", "Add"));
    btRemove->setText(QApplication::translate("Dialog", "Remove"));
    btCalib->setText(QApplication::translate("Dialog", "Calibrate"));
    video_image->setText(QApplication::translate("Dialog", "No preview"));
    lbImage->setText(QApplication::translate("Dialog", "No image"));
    btColours->setText(QApplication::translate("Dialog", "Colours"));
    btClick->setText(QApplication::translate("Dialog", "Click Corners"));
    btCorners->setText(QApplication::translate("Dialog", "Find Corners"));
    lbNotes->setText(QApplication::translate("Dialog", ""));
    okButton->setText(QApplication::translate("Dialog", "OK"));
    Q_UNUSED(Dialog);
    } // retranslateUi

};

namespace Ui {
    class Dialog: public Ui_Dialog {};
} // namespace Ui

#endif // UI_CALIBRATION_H
