//
// stumeikle
// canny (with postprocessing) example
//


#include <iostream>
#include <fstream>
#include <cstdlib>
#include <vector>
#include "image.h"
#include "image_fileinput.h"
#include "image_mesaoutput.h"
#include "image_funcs.h"
#include "property_image.h"
#include "edge_string_op.h"
#include "canny_tool.h"

using namespace std;
using namespace mimas;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {

    x11_display display;
    image<int> input;
    canny_tool<int> canny;
    edge_string_ptr_list edge_strings;
    edgestring_image eim;

    MMERROR( argc == 2, mimasexception, , "Gimme an image file!" );

    ifstream file( argv[1], ios::binary );
    file >> input;

    //(1) first run canny to extract a set of string_el strings
    edge_string_op::useFastMode();
    edge_strings=canny.findEdgeStrings( input );

    //(2) then create an image to contain them for visualisation
    // eim.setOwnership(false);
    eim.init( input.getWidth(), input.getHeight());
    eim.addStrings( edge_strings );
    image_mesaoutput< rgba< unsigned char > > win( &display );
    win << eim << mimas::pause();

  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
