#include <fstream>
#include <iostream>
#include "colour_properties_tool.h"
#include "image_fileinput.h"
#include "image_mesaoutput.h"

using namespace std;
using namespace mimas;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {
    x11_display display;
    image< rgba< double > > im;
    colour_properties_tool< double > prop;
    image_mesaoutput< rgba< unsigned char > > window( &display );

    cout << "Original image" << endl;
    ifstream file( "../images/stills/peppers-512x512-colour.ppm",
		   std::ios::binary );
    file >> im;
    window << im << mimas::pause();

    cout << "Increase contrast" << endl;
    prop.contrast(im, 0.5);
    window << im << mimas::pause();
	
    cout << "Decrease brightness" << endl;
    prop.brightness(im, -0.3);
    window << im << mimas::pause();

    cout << "Increase saturation" << endl;
    prop.saturation(im, 1.2);
    window << im << mimas::pause();

    cout << "Set Blue, Green and Alpha channels to zero" << endl << endl;
    prop.setChannel(im,0,"BGA");
    window << im << mimas::pause();

  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
