#include <iostream>
//#include "convert.h"
#include <image.h>
#include <fstream>
#include "image_fileinput.h"
#include "image_mesaoutput.h"
#include "image_funcs.h"
#include "property_image.h"
/**
* Test and demonstrate the trait conversion system
* and the convert_image functions.
* (in two flavours)
*
*
* @author Manuel Boissenin
* @date 15/02/2005
*
* Time-stamp: <2005-08-08 18:30:11 engmb>
* Copyright (C) 2005 by Manuel Boissenin
*
 ***********************************************************************/

using namespace mimas;

int main(int argc, char** argv) {
  int retVal = 0;
  try{
    MMERROR( argc == 2, mimasexception, ,
             "Syntax: " << argv[0] << " <image-file>" );
    x11_display display;
    image_mesaoutput< rgba<unsigned char>  > window( &display );
    image_mesaoutput< unsigned char > window2( &display );
    
    image<rgba<unsigned char> > colorImage;
    
    std::ifstream file( argv[1], std::ios::binary );
    MMERROR( file >> colorImage, mimasexception, ,
             "Error opening file '" << argv[1] << "'." );

    window << colorImage << mimas::pause();

    //return type has to be specified
    //grayImage = convert_image<unsigned char>(colorImage);
    
    image< unsigned char > grayImage( colorImage );
    window2 << grayImage << mimas::pause();

    image< float > doubleImage( grayImage );
    window2 << image< unsigned char >( doubleImage ) << mimas::pause();
    window << image< rgba<unsigned char> >(grayImage) << mimas::pause();

  } catch (std::exception &e) {
    std::cerr << e.what() << std::endl;
    retVal = 1;
  };
  return retVal;
}
