//
// Example application of despeckling
// NOTE: The original image (not the edge map) is despeckled
//
// Bala Amavasai <bala@amavasai.org>
//
// $Header: /cvs/mimas2/examples/despeckle/main.cc,v 1.1.1.1 2005/08/09 15:37:40 engmb Exp $
//

#include <iostream>
#include <fstream>
#include "image.h"
#include "image_fileinput.h"
#include "image_mesaoutput.h"
#include "image_funcs.h"
#include "canny.h"

using namespace std; 
using namespace mimas;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {
    x11_display display;
    image<int> image,tempimage;
    canny<int> canny;
    image_mesaoutput< unsigned char > window( &display );
    int count;

    MMERROR( argc == 2, mimasexception, , "Syntax: despeckle <image-file>" );

    cerr << "NOTE: The original image (not the edge map) is despeckled"
         << endl;

    ifstream file( argv[1], ios::binary );
    file >> image;

    // Do edge detection just to see effects of despeckling
    // on edges
    canny.setCannyAutoThres(false);
    canny.setCannyStdDev(0.5);
    canny.setCannyLowThres(20);
    canny.setCannyHighThres(91);

    for (count=0; count<10; count++)
      {
	tempimage = image;
	canny.getEdges(tempimage);
	window << tempimage << mimas::pause();

	// despeckle thrice in every loop
	for (int t=0; t<3; t++)
	  despeckleMedian(image);
      }
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
