#include <cassert>
#include <fstream>
#include <iostream>
#include <sys/timeb.h>
#include "image.h"
#include "image_fileinput.h"
#include "image_fileoutput.h"
#include "image_mesaoutput.h"
#include "colour_properties_tool.h"
#include "object.h"
#include "disparity_map.h"

using namespace std;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {
    x11_display display;
	timeb t1,t2;

	//load images
	image< rgba< int > > left, right;
	colour_properties_tool< float > tool;
   image_mesaoutput< rgba< unsigned char > > window( &display );
   
   ifstream file1( argv[1], ios::binary );
   ifstream file2( argv[2], ios::binary );
   file1 >> left;
   file2 >> right;

	ftime(&t1);

	disparity_map stereo(left,right, atoi(argv[3]),atoi(argv[4]),atoi(argv[5]));
	stereo.fastCalculateDisparityMap();

	ftime(&t2);
	printf("\nTime = %d ms \n",(int)( 1000*(t2.time-t1.time) + t2.millitm - t1.millitm));

	window << left << mimas::pause();
	//  window << right << mimas::pause();

	//triangulation

	//	triangularization triang(42, 800, stereo.disparity_map,"depth_map");
	//triang.calculateDistance();

	// to change	tool.scaleGray(stereo.disparity_map, 0, 255);

	ofstream fileOut( argv[6], ios::binary );
   fileOut << stereo.disparityMap;
   
   window << stereo.disparityMap << mimas::pause();
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
