//
// Example application using canny
// Bala Amavasai <bala@amavasai.org>
//
// $Header: /cvs/mimas2/examples/edgeCanny/main.cc,v 1.1.1.1 2005/08/09 15:37:40 engmb Exp $
//
#include <iostream>
#include <fstream>
#include "image_fileinput.h"
#include "image_fileoutput.h"
#include "image_mesaoutput.h"
#include "canny.h"
#include "mimasexception.h"

using namespace std; 
using namespace mimas;

int main(int argc, char **argv)
{
  int retVal = 0;
  try {
    MMERROR( argc == 6, mimasexception, ,
	     "Syntax: " << argv[0] << " image-filename image-output-filename lowThreshold HighThreshold StdDev" );
    image<int> someimage;
    canny<int> canny;
    x11_display display;
    image_mesaoutput< unsigned char > window( &display );

    canny.setCannyLowThres(atoi(argv[3]));
    canny.setCannyHighThres(atoi(argv[4]));
    canny.setCannyAutoThres(false); // default is true anyway
    canny.setCannyStdDev(atof(argv[5]));


    ifstream file( argv[1], ios::binary );

    file >> someimage;
    canny.getEdges(someimage);

    ofstream ofile(argv[2], ios::binary);
    ofile << setformat( "PNG8" ) << someimage;
   
    window << someimage << mimas::pause();
    
  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}
