#include "mimasconfig.h"
#include <GL/glut.h>
#include <image.h>
#include <image_mesaoutput.h>
#include <gnuplot.h>

using namespace mimas;
using namespace std;


image< rgba< unsigned char > > printCurve( int width, int height,
                                           double scale )
  throw (mimasexception)
{
  image< rgba< unsigned char > > img;
  gnuplot p( img, width, height );
  p << "set isosamples 40,40" << endl
    << "set xrange[-3:3]" << endl
    << "set yrange[-3:3]" << endl
    << "set zrange[-2:2]" << endl
    << "set hid; set nokey" << endl
    << "splot cos(x*x*" << scale << "+y*y*" << scale << ")" << endl;
  p.finish();
  return img;
}

int main( int argc, char *argv[] )
{
  int retVal = 0;
  try {

    glutInit( &argc, argv );

    x11_display disp;
    image_mesaoutput< rgba< unsigned char > > win( &disp );

    const int
      width  = 640,
      height = 480;

    for (int count=0; count<2; count++) {
      
      for (double i=1; i<2; i+=0.05)
        win << printCurve( width, height, i );
      
      for (double i=2; i>1; i-=0.05)
        win << printCurve( width, height, i );
      
    };

    win << mimas::pause();

  } catch ( exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };
  return retVal;
}

