#include <cassert>
#include <GL/glut.h>
#include <iostream>
#include "image.h"
#include "rgba.h"
#include "image_gstreamerinput.h"
#include "image_mesaoutput.h"
#include "rgba.h"

using namespace boost;
using namespace mimas;
using namespace std;

int main( int argc, char *argv[] )
{
  int retVal = 0;

  try {

    // Initialise GLUT.
    glutInit( &argc, argv );

    MMERROR( argc == 3, mimasexception, ,
             "Syntax: " << argv[0] << " shmkey semkey" );

    x11_display display;

    image_gstreamerinput< rgba< unsigned char > >
      gstreamer( atoi( argv[1] ), atoi( argv[2] ) );

    image_mesaoutput< rgba< unsigned char > > window( &display );

    image< rgba< unsigned char > > image;

    while ( gstreamer >> image )
      window << image << mimas::delay( 50 );
    
  } catch ( exception &e ) {

    cerr << e.what() << endl;
    retVal = 1;

  };

  return retVal;
}
