#include <boost/numeric/ublas/vector.hpp>
#include "nlinalg.h"

#define MIN(a,b) (a < b)?(a):(b)

using namespace boost;
using namespace mimas;
using namespace std;

typedef boost::numeric::ublas::vector< double > Vector;

/* Test example for Levenberg-Marquardt algorithm.

   The example is extracted from :
   http://www.tu-berlin.de/zrz/software/numerik/minpack/lmdif.txt
   Please refer to it for more information
*/

// calculates the function at the point x.
void fcn(int *m, int *n, double *x, double *fvec, int *iflag) {

  static double y[] = {0.14,0.18,0.22,0.25,0.29,0.32,0.35,
		       0.39,0.37,0.58,0.73,0.96,1.34,2.10,4.39};

  for(int i=1; i<=*m; ++i)
    fvec[i-1] = y[i-1] - (x[0] + i/((16-i)*x[1] + (MIN(i, 16-i))*x[2]));

}


int main( int argc, char *argv[] ) {

  Vector x(3);
  x[0] = 1;
  x[1] = 1;
  x[2] = 1;

  // call the levenberg-marqardt algorithm
  Vector r = lmdif1(x, &fcn, 15);

  cout << r[0] << " " << r[1] << " " << r[2] << endl;

  return 0;

}

