/**
 *
 *
 *
 *g++ -L/usr/X11R6/lib/ -lGL -lGLU -lglut
 *
 * Time-stamp: <2006-05-12 12:57:14 engmb>
 * Copyright (C) 2004 by Manuel Boissenin
 *
 * @author Manuel Boissenin
 * @date 16/09/2004
 *
 ***********************************************************************/
#ifndef MMVL_OPENGLOBSERVER_H_INCLUDED
#define MMVL_OPENGLOBSERVER_H_INCLUDED

#include <iostream>
#include <vector>
#include <sstream>
#include <fstream>
#include <iomanip>
#include <stdlib.h>
#include <image.h>
#include <rgba.h>
#include <mesa_offscreen.h>
//#include <image_mesaoutput.h>
#include <image_fileoutput.h>

#include <hypothesis_filter.h>
#include <hypothesis3D.h>
#include "rubiks_cube.h"

using namespace mimas;

namespace mimas{
  namespace hf{  
    /**
     *Carefull this class cannot be used in
     *conjonction with an image_mesaoutput
     *because it is using an mesa_offscreen !!!?why?
     *For displaying you can use an image_qtouput
     **************************/
    
    template<typename Hypothesis_T, typename Pixel_T>
    class openGL_observer{
    public:
      std::vector<Point> pixels;
      image<int> filteredImage; ///< has to be instanciated before the image can be observed.

      image<Pixel_T> offscreenImage; ///<where is done the offscreen rendering      

      class set{
      public:
	x11_display *disp;
	set(x11_display *dpy)
	  :disp(dpy){}
      };
      
      openGL_observer(image< Pixel_T> &image, set o_set)
	:image_ref(image),disp(o_set.disp)  
      {
	//init the offscreen rendering facility
	offscreenImage.init(image_ref.getWidth(), image_ref.getHeight());
      }
      
      //could be called by the filter, actually the observer class can be considered as part of the filter
      //an update of the filter should triger an update of this class ->how to manage arguments? 
      //This observer is only to be used with hypothesis3D, a compilation error will
      //indicate if a user try to use it differently.
      void observe(hypothesis3D &p);

      void draw(hypothesis3D &h, Pixel_T &color)
      {
#ifndef NDEBUG
	h.debug();
#endif
	calculateDistance(h);

	for(std::vector<Point>::iterator itm = pixels.begin(); itm != pixels.end(); itm++)
	  {
	    image_ref.setPixel((int)(*itm)(0),(int)(*itm)(1), color);
	  }
      }      

      void draw(std::vector<hypothesis3D> &hypotheses, Pixel_T &color)
      {
	typename std::vector<Hypothesis_T>::iterator it_h;
	
	for(it_h = hypotheses.begin(); it_h != hypotheses.end(); it_h++)
	  draw(*it_h, color);
      }
      
    protected: 
      double evaluateDistance(void);
      double calculateDistance(hypothesis3D &h);
      void improve(hypothesis3D &h, double &dist);

      //might be moved to another policy (can be generalize for 2D examples too)
      float gradientDescent(hypothesis3D &h, double &dist);

    private:
      image<Pixel_T> &image_ref; ///<reference to the observed image

      x11_display* disp;
      mesa_offscreen<Pixel_T> *offscr;
    };

#include "openGL_observer.tcc"
  }
}
#endif










