//
// Colour segmentation using the Spherical Coordinate Transform
// @author Bala Amavasai (bala@amavasai.org)
// @date Wed Mar 16 19:15:58 GMT 2005
// $Header: /cvs/mimas2/examples/segmentsct/main.cc,v 1.1.1.1 2005/08/09 15:37:40 engmb Exp $
//

#include <fstream>
#include <iostream>
#include "segment_sct_tool.h"
#include "image_fileinput.h"
#include "image_mesaoutput.h"
#include "rgba.h"

using namespace mimas;
using namespace std;

int main(int argc, char **argv)
{
	int retVal = 0;
	try {
	  x11_display display;
		segment_sct_tool scttool;

		MMERROR( argc >= 4, mimasexception, ,
				"Please see the README file for details of how to run this app" );

		
		// load in the image that contains sample colours
		image< rgba< unsigned char > > img;
		ifstream imFile( argv[1], ios::binary ); imFile >> img;

		// split angles
		scttool.setSplitA(atoi(argv[2]));
        scttool.setSplitB(atoi(argv[3]));


		// segment the image
		image< rgba< unsigned char > > imgout;
		scttool.segment(img,imgout);

		image_mesaoutput< rgba< unsigned char > > window( &display );
		window << imgout << mimas::pause();
		
	} catch ( exception &e ) {
		cerr << e.what() << endl;
		retVal = 1;
	};
	return retVal;
}
