#include <fstream>
#include <GL/glut.h>
#include "image_fileinput.h"
#include "image_mesaoutput.h"

using namespace std;
using namespace mimas;

// Minimal program for displaying multiple images from a single file.
int main( int argc, char *argv[] )
{
  int retVal = 0;

  try {

    // Initialise GLUT.
    glutInit( &argc, argv );
    
    // Check command-line.
    MMERROR( argc == 2, mimasexception, ,
             "Syntax: " << argv[0] << " <image>" );

    // Open X11 display.
    x11_display disp;

    // Load file.
    ifstream f( argv[1], ios::binary );
    image_fileinput< rgba< unsigned char > > input( f );
    
    // Open window.
    image_mesaoutput< rgba< unsigned char > > win( &disp );

    // Allocate image.
    image< rgba< unsigned char > > img;

    while( input ) {
      
      // Read image.
      input >> img;

      // Display image.
      win << img << mimas::delay( 300 );

    };

    win << mimas::pause();

  } catch ( exception &e ) {

    // Print error message.
    cerr << e.what() << endl;
    retVal = 1;

  };
  
  return retVal;
}
