#include <fstream>
#include <GL/glut.h>
#include "image_fileinput.h"
#include "image_mesaoutput.h"

using namespace std;
using namespace mimas;

// Minimal program for displaying single image.
int main( int argc, char *argv[] )
{
  int retVal = 0;

  try {

    // Initialise GLUT.
    glutInit( &argc, argv );
    
    // Check command-line.
    MMERROR( argc == 2, mimasexception, ,
             "Syntax: " << argv[0] << " <image>" );

    // Open X11 display.
    x11_display disp;

    // Load single image.
    ifstream f( argv[1], ios::binary );
    image< rgba< unsigned char > > img;
    f >> img;

    // Display the image.
    image_mesaoutput< rgba< unsigned char > > win( &disp );
    win << img << mimas::pause();

  } catch ( exception &e ) {

    // Print error message.
    cerr << e.what() << endl;
    retVal = 1;

  };
  
  return retVal;
}
