#include <fstream>
#include <GL/glut.h>
#include "image_v4linput.h"
#include "image_mesaoutput.h"

using namespace std;
using namespace mimas;

// Minimal program for accessing video data using libxine.
int main( int argc, char *argv[] )
{
  int retVal = 0;

  try {

    // Initialise GLUT.
    glutInit( &argc, argv );

    // Open X11 display.
    x11_display display;

    // Open V4L device.
    image_v4linput< rgba< unsigned char > > input( "/dev/video0" );

    // Open window.
    image_mesaoutput< rgba< unsigned char > > window( &display );

    // Allocate image.
    image< rgba< unsigned char > > img;

    // Loop for images.
    while ( input ) {
      
      // Grab image.
      input >> img;

      // Display image.
      window << img;
      
    };

  } catch ( exception &e ) {

    cerr << e.what() << endl;
    retVal = 1;

  };
  
  return retVal;
}
