#include <GL/glut.h>
#include <iostream>
#include "mesa_onscreen.h"
#include "x11_display.h"
#include "x11_window.h"

using namespace mimas;
using namespace std;

class custom_window: public x11_window
{
public:
  custom_window( x11_display *_display, int _width, int _height ):
    x11_window( _display, _width, _height )
  {
  }
protected:
  virtual void paint_event(void) throw (mimasexception) {
    // Clear background.
    mesa_onscreen mesa( this );
    mesa.ortho2D();
    mesa.setColor( rgba< unsigned char >( 0, 0, 255 ) );
    glRectf( 0, 0, width, height );
    mesa.setColor( rgba< unsigned char >( 255, 0, 0 ) );
    glRectf( 10, 10, width - 10, height - 10 );
    mesa.finish();
  }
};

int main( int argc, char *argv[] )
{
  int retval = 0;
  
  try {
    
    // Initialise GLUT.
    glutInit( &argc, argv );

    // Access display.
    x11_display displ;

    // Open window.
    custom_window win1( &displ, 640, 400 ), win2( &displ, 400, 200 );
    
    // Process events.
    displ.event_loop();
    
  } catch ( exception &e ) {

    // Display error message and set return value.
    cerr << e.what() << endl;
    retval = 1;
    
  };

  return retval;
}
