#include <iostream>
#include <xalanc/XPath/XPathInit.hpp>
#include <xercesc/util/PlatformUtils.hpp>
#include "xml_document.h"
#include "xml_node_reference_list.h"

using namespace mimas;
using namespace std;

int main( int argc, char *argv[] )
{
  int retVal = 0;

  XMLPlatformUtils::Initialize();

  try {
    // Static initalisation of XPath utilities.
    XPathInit theXPathInit;

    xml_document document
      ( "http://www.wedesoft.demon.co.uk/2005/test-schema test.xsd" );
    document.load( "test.xml" );
    xml_node_reference_list l( document.getDocumentElement().
                                  selectNodes( "a/@b" ) );
    for ( int i=0; i<l.getLength(); i++ )
      cout << "value-of( a[position()=" << i << "]/@b ) = "
           << l.item( i ).getNodeText() << endl;
  } catch ( std::exception &e ) {
    cerr << e.what() << endl;
    retVal = 1;
  };

  XMLPlatformUtils::Terminate();

  return retVal;
}
