#ifndef MMVL_CONDENSATION_HH_INCLUDED
#define MMVL_CONDENSATION_HH_INCLUDED

#include <vector>
#include <cassert>
#include "dice.h"

namespace mimas{
  namespace hf{  

/**
 *@ingroup pf
 *@brief a picking policy.
 *
 *Reference paper
 *
 *This is an implementation of the condensation filter.
 *
 * @sa hypothesis_filter 
 * @author: Manuel Boissenin
 * @date: june 2003
 *
 *************************************************/    
    template<typename Hypothesis_T>
    class condensation
    {
    public:
      condensation(std::vector<Hypothesis_T> &hypotheses)
	:hypotheses_CD(hypotheses){}
	
    protected:
      int pick_base_hypothesis(void);
      std::vector<Hypothesis_T> &hypotheses_CD;
      
    private:
    
      std::vector<double> cumulative_weight;
      void calculate_cumulative(void);
    };
    
#include "condensation.tcc"
  } 
}
#endif
