#define GLX_GLXEXT_PROTOTYPES
#include <GL/glx.h>

namespace mimas {

template< typename T >
image_mesaoutput< T >::image_mesaoutput( x11_display *_display,
					 int _width, int _height ):
  window( new image_window( _display, _width, _height ) ),
  interval( 0 )
{
}

template< typename T >
void image_mesaoutput< T >::wait( int milliSeconds )
{
  window->get_display()->event_loop( milliSeconds );
}

template< typename T >
void image_mesaoutput< T >::pause(void)
{
  window->get_display()->event_loop();
}

template< typename T >
void image_mesaoutput< T >::write( const image< T > &img )
{
  window->resize( img.getWidth(), img.getHeight() );

  if ( interval > 0 ) {
    int delay = interval - (int)( time.elapsed() * 1000 );
    wait( delay );
  };

  time.reset();

  window->setImage( img );
  window->repaint();
  window->get_display()->process_events();
}

};
