#ifndef MMVL_NO_COMPENSATION_H
#define MMVL_NO_COMPENSATION_H

#include <boost/numeric/ublas/vector.hpp>

namespace mimas{
  namespace hf{
   
    typedef boost::numeric::ublas::vector<float> Point;

    /**@ingroup pf
       @brief default compensation policy.
       
       @author Manuel Boissenin
    */
    template<typename Hypothesis_T>    
    class no_compensation
    { 
    public:
      //This function does nothing but it avoids problem
      //when the track() function from hypothesis filter is used
      //So it allows to keep compatibility. The optional track() function 
      //and a way to have reusable building block may have to be rethinked
      inline void save_location(const Hypothesis_T &p){}

    protected:
      //and that?!!!!
      inline void outweigh(Hypothesis_T &h){}
    };
  }
}
#endif
