#ifndef PRIMITIVE_H
#define PRIMITIVE_H

namespace mimas {
/**
 * A pixel.
 */
struct pixel {
  unsigned int x,y;
  pixel(int x = 0, int y = 0):
    x((unsigned int)(x)), y((unsigned int)(y))
    {
      // is assert useful ?
      assert(x >=0 && y>= 0);
    }
};

/**
 * A double-precision pixel. Useful for sub-pixel accuracy.
 */
struct pixel_f {
  double x, y;
  pixel_f( double x = 0, double y = 0): x(x), y(y){ assert(x >=0 && y>= 0); }
};

/**
 * A int point.
 */
struct point {
  int x,y;
  point(int x = 0, int y = 0): x(x), y(y){}
};

/**
 * A float point.
 */
struct point_f {
  double x,y;
  point_f(double x = 0, double y = 0): x(x), y(y){}
};

/**
 * A segment (made of 2 points).
 */
template< typename T >
struct segment {
  T p1,p2;
  segment(T &p1, T &p2): p1(p1), p2(p2){}
};

}    
#endif
