//
// property_image
// 
// an image which contains pointers to structures which describe
// the underlying bitmap properties.
// 
//
// stumeikle Sun May 12 20:23:32 2002
//

#ifndef PROPERTY_IMAGE_H
#define PROPERTY_IMAGE_H

#include "mimasconfig.h"
#include "edge_string.h"
#include "image.h"
#ifdef HAVE_OPENGL
#include "image_mesaoutput.h"
#endif
#include "prop.h"

namespace mimas {
  // class edge_string_ptr_list;
  // class edge_string;
  class property_image : public image< prop_ptr >
{
    // an image of pointers to properties
//  private:
// 	bool	owns_props;
// 		//does this structure have responsibility for 
// 		//deleting the prop structures??

    protected:
	bool	draw_contrast;
		//should props be drawn so as to indicate their strengths?

    // we could override the display function and the read/write to file
    // functions here...
    public:
	property_image(void)
	{
     // owns_props=true;
	    draw_contrast = false;
	}
	
	// ~property_image(void);
	
	//overloaded functions from the base image class
	//display needs to be changed now
	// void display(void);
  // void clear( void );
	
	//owernership if true means that pointed to structures will be 
	//deleted when this image is deleted
  // void setOwnership( bool b ) { owns_props = b; }
	void doDrawContrast() { draw_contrast = true; }
   bool getDrawContrast() const { return draw_contrast; }

	//a helpful visualisation tool...
	void addStrings( edge_string_ptr_list& strings );
	void addStringsWithFilter( edge_string_ptr_list& strings );

	void operator+=( property_image& );

};


//handy macros
typedef property_image edge_image;
typedef property_image corner_image;
typedef property_image edgestring_image;

#ifdef HAVE_OPENGL
image_mesaoutput< rgba< unsigned char > > &operator<<
  ( image_mesaoutput< rgba< unsigned char > > &output,
    const property_image &image );
#endif

}

#endif

