#ifndef __XMLNODE_TCC
#define __XMLNODE_TCC

#include <DOMSupport/DOMServices.hpp>

namespace mimas {

template< class T >
xml_reference<T>::xml_reference( T *_node, xml_document *_document ):
  node( _node ), document( _document )
{}

template< class T >
xml_reference<T>::xml_reference( const xml_reference< T > &r ):
  object( r ), node( r.node ), document( r.document )
{}

template< class T >
xml_reference< T > &xml_reference< T >::operator=
  ( const xml_reference< T > &r )
{
  node = r.node;
  document = r.document;
  return *this;
}

template< class T >
std::string xml_reference< T >::getNodeText(void) const
  throw (mimasexception,XMLException)
{
  MMERROR( document != NULL, mimasexception, ,
           "Can not select nodes from empty XML document." );
  XalanDOMString text;
  DOMServices::getNodeData( *node, text );
  CharVectorType result;
  MMERROR( TranscodeToLocalCodePage( text, result, true ), mimasexception, ,
           "Xalan-C failed to transcode some text. Check the content of "
           "the environment variable `LANG'." );
  return c_str( result );
}

// Instantiation.
template <>
xml_node_reference_list xml_reference< XalanElement >::selectNodes
  ( const char *xPath ) const throw (mimasexception,XMLException);

};

#endif
