//
// reorganising the .h into .h and .cc files
// stuart meikle Tue Jul  4 10:28:41 2000
//
//
// Stuff added by bpa
//
// void	pgh_scene::updateSceneLines( char *newscenePGM, int w, int h )
//
// THE FOLLOWING IS NOT WORKING PROPERLY! DO NOT USE
// void pgh_scene::addModel(char *pgmfilename , const char *modelname )


#include <fstream>
#include "mimasconfig.h"
#include "pgh.h"
#include "pgh_scene.h"
#include "object_instance_list.h"
#include "linalg.h"
#include "image.h"
#include "image_funcs.h"
#include "image_fileinput.h"
#include "image_op.h"
#include "canny_tool.h"
#include "slap_tool.h"
#include "edge_string.h"
#include "xml_document.h"

namespace mimas {
using namespace std;
using namespace boost;

/**
 * scene constructor. just assigns default values to the vars
 *
 */
pgh_scene::pgh_scene(void)
{
#ifdef HAVE_GETTIMEOFDAY
    timestamp.tv_usec = timestamp.tv_sec = 0;
#endif
    centroid_posn_x = centroid_posn_y = 0.0;
    image_height = image_width = -1;
    location_hough_type = points;

    prefiltering = false;
    pgh_match_thresh = 0.5;	                 // ranges between 0.0 (no pgh match) and 1.0 (identical pgh)
    hough_peak_thresh = 0.35;                    // ranges between 0.0 (everything) and 1.0 (only highest peak)
}

/**
 * destructor. delete all the allocated arrays!
 */
pgh_scene::~pgh_scene(void)
{
    //lots to delete
    //delete the scene line stuff
    //delete the match score stuff
    //?do we own the object stuff itself?

    //base class stuff is deleted automatically
    //delete the match score stuff

//     sms_it	match_it;

//     for(match_it = match_score_list.begin(); match_it != match_score_list.end(); match_it++)
//     {
// 		delete[] (*match_it); //	delete (*match_it);
//     }

//     //delete all the objects which we created / loaded
//     list<bool>::iterator bi;
//     obj_it oi;

//     for(oi = objects_of_interest.begin(), bi=we_created_obj.begin();
// 		oi!= objects_of_interest.end(); ++oi, ++bi)
//     {
// 		if (*bi) delete *oi;
//     }


    //!FUTURE: delete the object instance list


	// delete scene lines, added by fbc 15.01.02
	deleteLineInfo();
}


//
// added by fbc, 15.11.01 - to be thoroughly tested for memory leaks....
//

/**
 * remove all allocated data and reset to post-construction cleanliness. I have no idea why though.
 */
void	pgh_scene::clear(void)
{
	// from the destructor, BUT the pgh_2dobject objects
	// are not deleted, instead ONLY cleared, fbc 15.01.02

    //lots to delete
    //delete the scene line stuff
    //delete the match score stuff
    //?do we own the object stuff itself?

    //base class stuff is deleted automatically
    //delete the match score stuff

//     sms_it	match_it;

//     for(match_it = match_score_list.begin(); match_it != match_score_list.end(); match_it++)
//     {
// 		delete[] (*match_it); //	delete (*match_it);
//     }
    match_score_list.clear();

    //delete all the objects which we created / loaded
    /*
    list<bool>::iterator bi;
    obj_it oi;

    for(oi = objects_of_interest.begin(), bi=we_created_obj.begin();
		oi!= objects_of_interest.end(); ++oi, ++bi)
    {
		pgh_2dobject *object = *oi;
		object->clear();
    }

    */
    objects_of_interest.clear();
    // we_created_obj.clear();

    //!FUTURE: delete the object instance list


	// delete scene lines, added by fbc 15.01.02
	deleteLineInfo();
}


// added by bpa
// NOT WORKING PROPERLY! DO NOT USE
// removed by stumeikle as we aint got no PolyLines right now
/*
void 	pgh_scene::addModel(char *pgmfilename , const char *modelname)
{
	pgh_2dobject *o = new pgh_2dobject;
	line_ptr_list *geom = new line_ptr_list;
	line	*l;
	Poly_Lines poly_lines;

	poly_lines.No_Lines = 0;
	poly_lines.Lines = NULL;

	o->setName(modelname);

	if (pgm2lines(pgmfilename, "",
			canny_sigma, canny_precision, canny_lowthre, canny_upthre, canny_lenthre,
			pgh_angle_sigma,
			roi_lx, roi_ly, roi_ux, roi_uy,
			&poly_lines) != 0)
	{
		mm->Error() << "Lines from scene could not created by pgm2lines()" << endl;
		return;
	}


	for (int Index = 0; Index < poly_lines.No_Lines; Index++)
	{
		l = new line(poly_lines.Lines[Index].pt1.X,
						poly_lines.Lines[Index].pt1.Y,
                      	poly_lines.Lines[Index].pt2.X,
                      	poly_lines.Lines[Index].pt2.Y);

		geom->push_back(l);
	}

	//addModel(geom,modelname);

	o->createFromLines(geom);
	addModel(o);
	LIST_DESTROY( line*, geom );

	if (poly_lines.Lines)
	{
		free(poly_lines.Lines);
		poly_lines.Lines = NULL;
	}
}
*/

/**
 * add a model. this means notify the scene that there should be a new 'object of interest'.
 * the object is created as a pgh_2dobject from the list of lines given.
 */
void pgh_scene::addModel( const line_ptr_list& geom,
                             const string &name )
{
  pgh_2dobject_ptr o( new pgh_2dobject );

    o->setName(name);

    //might need to pass pairwise parameters in here
    o->createFromLines(geom, &centroid_posn_x, &centroid_posn_y ); //COPIES THE STRUCTURE
    addModel( o );
}


/**
 * add a model. this means notify the scene that there should be a new 'object of interest'.
 */
/*
void	pgh_scene::addModel( pgh_2dobject *ob )
{
    //check the form of the histograms here. are they directed etc?
    addModel( ob, false );
}
 */

/**
 * add a model. this means notify the scene that there should be a new 'object of interest'.
 * User can specify who (user or pgh_scene) owns the data with bool wco .
 */
void	pgh_scene::addModel( pgh_2dobject_ptr ob )
{
    objects_of_interest.push_back( ob );

    //create an array for the results of comparisons
    scene_match_score_array sms( new scene_match_score[ getNumScenePGHs() ] );
    match_score_list.push_back( sms );
    // we_created_obj.push_back( wco );
}


/**
 * locate the given object in the scene. the object must have been previously
 * added to the list of objects of interest using the addModel() functions.
 * This method returns a list of the object instances found in the scene .
 */
object_instance_list_ptr pgh_scene::findModel( pgh_2dobject_ptr ob )
{
    //algo:
    //compare each of the histograms in ob to all of the scene histograms
    //store the best match for each histogram in ob

    // important: we need to compare each line in the scene to each line
    // in the model and not the other way around as there may be (**)
    // more than one instance of the model in the scene.

    //threshold the matches somehow, and discard those under a particular
    //strength

    //create a location histogram with the rest
    //do non-maxima suppression
    //threshold the remaining peaks.
    //locate the objects


#ifdef HAVE_GETTIMEOFDAY
    //(0) check that the scene has some info in it
    MMERROR( timestamp.tv_sec != 0, mimasexception, ,
             "initialise the scene before looking for objects therein!" );
#endif

    //(1) find 'ob' in the list of possibles.
    obj_it	oi;
    sms_it	si;

    for(oi = objects_of_interest.begin(), si = match_score_list.begin();
		oi != objects_of_interest.end();
		oi++, si++)
    {
		if (*oi == ob)	break;
    }

    
    if (oi == objects_of_interest.end())
    {
#ifndef NDEBUG
		cerr << "couldn't find the object you're talking about" << endl;
#endif
		return object_instance_list_ptr();
    }


    //(2) foreach line in the scene. compare scene line to each of the object lines
    //    and store the results in the sms array for that object
    pgh_ptr_list	*scene_pgh_list;
    pgh_ptr_list::iterator pghlist_it;
    pgh_ptr_list	*obj_pgh_list;
    pgh_ptr_list::iterator pghlist_it2;
    line_ptr_list_ptr scene_geom_list;
    line_ptr_list::iterator line_it;
    line_ptr_list_ptr obj_geom_list;
    line_ptr_list::iterator line_it2;

    int	i;
    double overlap;

    scene_match_score_array match_score_array = *si;

	scene_pgh_list = getScenePghList();
	scene_geom_list = getListofLinesGUI();
	obj_pgh_list = ob->getPghList();
	obj_geom_list = ob->getListofLines();

    for(i = 0, pghlist_it = scene_pgh_list->begin(), line_it = scene_geom_list->begin();
		pghlist_it !=scene_pgh_list->end();
		pghlist_it++, line_it++, i++)
    {
		line_ptr scene_line = *line_it;
		pgh_ptr scene_pgh = *pghlist_it;
		Vector midpoint( scene_line->findMidPoint() );

		double max_overlap  = 0.0;
    	pgh_ptr max_pgh;// = NULL;
    	line_ptr max_line;

		// check whether the object's ROI is valid, fbc 4.12.01
		if (ob->roi_ux > ob->roi_lx && ob->roi_uy > ob->roi_ly)
		{
			// check whether scene line's midpoint lies within object's ROI, fbc 4.12.01
			if (midpoint(0) < ob->roi_lx ||
				midpoint(0) > ob->roi_ux ||
				midpoint(1) < ob->roi_ly ||
				midpoint(1) > ob->roi_uy)
			{
				match_score_array[ i ].best_match = max_overlap;
				match_score_array[ i ].object_pgh = max_pgh;
				match_score_array[ i ].object_line= max_line;
				continue;
			}
		}

		for(pghlist_it2 = obj_pgh_list->begin(), line_it2 = obj_geom_list->begin();
	     	pghlist_it2 != obj_pgh_list->end();
	     	pghlist_it2++, line_it2++)
		{
			pgh_ptr obj_pgh = *pghlist_it2;

			overlap = dotProduct( *obj_pgh, *scene_pgh );

	    	if (overlap > max_overlap)
	    	{
				max_overlap = overlap;
				max_pgh = obj_pgh;
				max_line = *line_it2;
	    	}
		}

		//store the best result in the match_score_list array.
		match_score_array[ i ].best_match = max_overlap;
		match_score_array[ i ].object_pgh = max_pgh;
		match_score_array[ i ].object_line= max_line;
    }


    //(3) ... and that will do for now
    //^^ more to come in here -->
    // filter the matches based on some criterion or another

    // now that we've matched all the scene lines we need to create a location hough to find all
    // instances

    return  locateObject( match_score_array, ob );
}

/**
 * once the matching of the lines has occured, then attempt to locate the object in the scene.
 *
 */
object_instance_list_ptr pgh_scene::locateObject( scene_match_score_array match_array, pgh_2dobject_ptr ob )
{
    //NOTE: need to pass the object too , just so we can extract the size etc from it
    //we could create the histogram here and set the translation from the
    //image to the location hough.

    //create a location hough using the passed match scores
    //
    object_instance_list_ptr v;

    switch( location_hough_type )
    {
		case long_lines:    v = locateObject_longLines( match_array, ob );
						    break;

		case short_lines:   MMERROR( false, mimasexception, ,
                                   "haven't implemented this yet!" );
                     break;

		case points:		v = locateObject_points( match_array, ob );
							break;
    }

    if (v->empty())
    {
		// delete v;
		return object_instance_list_ptr();
    }

    // now orientate the object(s) and remove further bad instances
    for( coordinate_xform_ptr_list::iterator i = v->getList().begin();
         i != v->getList().end(); ++i )
    {
		coordinate_xform_ptr m = (*i);
		Vector mv( m->getDisplacement() );
		angle a;

		//try
		//{
	    	a = orientObject(match_array, *ob, mv);
	    	m->setRotation(a);
		//}
		//catch( mimasexception )
		//{
	    	// in this case the orientation calculation indicates that a bad peak
	    	// was found in the first place
		//}
    }

    return v;
}

/**
 * post matching, attempt to locate the object by drawing "long lines" in a hough space
 */
object_instance_list_ptr pgh_scene::locateObject_longLines( scene_match_score_array match_array ,
								pgh_2dobject_ptr ob )
{
    //basic algo:
    //(1) allocate a hough transform for the location of the object
    //(2) make an entry into the hough for each match array score,
    //	  FILTERING each match score according to some criterion beforehand.
    int			i;
    double		width, height;
    int			object_size;
    line_ptr_list_ptr scene_lines;
    Vector origin_shift( 2 );
    line_ptr_list::iterator	scene_line_it;

    if (ob->getWidth() > ob->getHeight()) //allow for rotations of the object
	object_size = ob->getWidth();
    else
	object_size = ob->getHeight();

    width = (double)(image_width + object_size);
    height= (double)(image_height+ object_size);

    hough_transform	h;

    h.init( (int)width, (int) height );
    origin_shift(0) = object_size + centroid_posn_x;
    origin_shift(1) = object_size + centroid_posn_y;

    //a note about the co-ordinates of this hough transform.
    //0,0 on the hough transform corresponds to -object_sizex -object_size on
    //the image plane.
    scene_lines = getListofLines();

    for(i=0, scene_line_it=scene_lines->begin();
	i< getNumScenePGHs(); i++, scene_line_it++)
    {
      line_ptr 	scene_line = *scene_line_it;

      Vector s(2),e(2);

	s = scene_line->getStart() + origin_shift; //these 3 lines for debug purps
	e = scene_line->getEnd()   + origin_shift;
	h.addGaussLine( line( s,e ), 1.0, 1, 0.01 );

	//@there's lots of ways to do this of course. best N etc.
	if (match_array[i].best_match > pgh_match_thresh)
	{
	    //make a short lines entry for the time being
	    //the length of the line ( and i'm guessing here ) needs to be
	    //2*the model line length + the scene line length.
	    //if the histogram type isn't directed then we'll need two lines too.

	    //the position of the center of the line on the output histogram is
	    //the position of the centroid.
	    line_ptr	model_line;
	    Vector
         mid_point(2), smid_point(2), unit_scene_line(2),
         start(2), end(2);
	    angle	a;
	    int		acount;
	    double	l;

	    model_line = match_array[i].object_line;

	    //(1) find the angle (in 360 space) from the model line to the scene line
	    //a = scene_line->angle( model_line );
	    a = model_line->getAngle( *scene_line );

	    for(acount=0;acount<2;acount++, a+=M_PI)
	    {
		//(for most pgh types we'll have to make two entries 180' appart

	        //(2) find the centre of the model_line
		mid_point = model_line->findMidPoint();

	        //(3) rotate the vector according to the angle
		mid_point = rotate( mid_point, -a );

		//(4) find the mid point of the scene line
		smid_point= scene_line->findMidPoint();

	        //(5) move back to the centroid
		smid_point = smid_point - mid_point;

    		//(6) now draw a line in the hough space, parallel to the scene line
		//which is centred on this point and which has length
		// = 2*modellinelen+scenelinelen
		unit_scene_line = unit( scene_line->getVector() );
		l     = (2* model_line->length() + scene_line->length() ) /2.0;

		Vector temp( unit_scene_line *l );
		start = smid_point - temp;
		end   = smid_point + temp;
		//move the image co-ordinates to the hough co-ordinates.
		//(@ could add a scale change here in future )
		start = start + origin_shift;
		end   = end + origin_shift;

		//we should calculate the weight accuracy and precision required for the
		//line in the hough, but for now we'll hack it! WARNING @
		h.addSlopedGaussLine( line( start, end ),  match_array[i].best_match, 3, 0.01 );

		//(7) if we're not using directed histograms, repeat the above with
		//180 degrees added to the angle a.
		if (getPghType() == pgh_type_directed)
		    break;
	    }
	}
    }

    // we shouldn't normalise this hough because we'll throw away info about the
    // `real' likelihoods for when there are more than one object instance in the image

    // ALGO:
    // so here's the problem right now: what constitutes a well located object? the
    // number of entries which are summed at the possible centroid position will depend
    // upon the *NUmber of lines in the object model* . Which is strange because
    // simplistically it means that we'll always be more `likely' to locate objects such
    // as octagons in the image in preference to rectangles -> their centroids will be
    // represented in the plots with larger peaks.

    // actually pairwise is really quite poor at locating object instances!!

    // anyway! we can weight the histogram entries based on the number of lines in the
    // model. if there were , for example 4 lines in the model, then the centroid, in the
    // best possible case would have a peak value of 4.0. So peaks of value 4.0 indicate
    // well located instances.

    // we might be able to do some clever things with the orientation calcualtion
    // to remove peaks which are rubbish.

    //so ! (A) -> non-maxima suppression
    int	x,y;

    normaliseIt( h, 0.0, 255.0 );
    thresholdIt( h, hough_peak_thresh * 255.0 );

    hough_transform	newh;

    newh.init( h.getWidth(), h.getHeight() );

    //peak enhancement
    //(should use a convolution , but i haven't written it yet!)
    for(y=0;y<h.getHeight(); y++)
    {
	for(x=0;x<h.getWidth();x++)
	{
	    double v;

	    v = h.pixel(x,y);
	    if ( v>=h.getPixel( x-1, y-1 ) &&
		 v>=h.getPixel( x  , y-1 ) &&
		 v>=h.getPixel( x+1, y-1 ) &&
		 v>=h.getPixel( x-1, y   ) &&
		 v>=h.getPixel( x+1, y   ) &&
		 v>=h.getPixel( x-1, y+1 ) &&
		 v>=h.getPixel( x  , y+1 ) &&
		 v>=h.getPixel( x+1, y+1 ))
         newh.pixel(x,y) = v;
	}
    }

    //store the remaining points as vectors and return the lists
    object_instance_list_ptr retval( new object_instance_list );
    retval->setObject(ob);
    for(y=0;y<newh.getHeight(); y++)
    {
	for(x=0;x<newh.getWidth();x++)
	{
	    if (newh.pixel(x,y)!=0)
	    {
         coordinate_xform_ptr o( new coordinate_xform );

         Vector displacement( 2 );
         displacement( 0 ) = x-object_size; displacement( 1 ) = y-object_size;
         o->setDisplacement( displacement );
		retval->push_back(o);

		int	i,j;

		//blank the neighbourhood in case its a blurry point
		for(j=y-2;j<=y+2;j++)
		{
		    for(i=x-1;i<=x+2;i++)
			newh.setPixel(i,j,0);
		}
	    }
	}
    }

    return retval;
}


/**
 * post matching, attempt to locate the object in the scene by filling a hough transform with
 * location estimate 'points'
 */
object_instance_list_ptr pgh_scene::locateObject_points( scene_match_score_array match_array ,
							    pgh_2dobject_ptr ob )
{
    //NOVEL ALGORITHM BY STU MEIKLE Fri Jun 30 14:48:59 2000
    //
    //basic algo:
    //(1) allocate a hough transform for the location of the object
    //(2) make an entry into the hough for each match array score,
    //	  FILTERING each match score according to some criterion beforehand.
    //
    // iterate through all possible pairs of lines. plot only the intersections
    // on the Hough Transform, and **heres the novel bit** discard line pairs which
    // are not roughly in the same alignment in the scene as in the model.

    // ... makes me think of scale invariant houghs ...

    int			i,j;
    double		width, height;
    int			object_size;
    line_ptr_list_ptr scene_lines;
    Vector origin_shift(2);
    line_ptr_list::iterator	scene_line_it1, scene_line_it2;

    if (ob->getWidth() > ob->getHeight()) //allow for rotations of the object
	object_size = ob->getWidth();
    else
	object_size = ob->getHeight();

    width = (double)(image_width + object_size);
    height= (double)(image_height+ object_size);

    hough_transform	h;

    h.init( (int)width, (int) height );
    origin_shift(0) = object_size + centroid_posn_x;
    origin_shift(1) = object_size + centroid_posn_y;

    //a note about the co-ordinates of this hough transform.
    //0,0 on the hough transform corresponds to -object_sizex -object_size on
    //the image plane.
    scene_lines = getListofLines();

    for(j=0, scene_line_it2=scene_lines->begin(); j< getNumScenePGHs(); j++, scene_line_it2++)
    {
		{
			//debug stuff
			//	vector	s,e;
			//	line		*scene_line = *scene_line_it2;
			//	s = *scene_line->getStart() + origin_shift; //these 3 lines for debug purps
			//	e = *scene_line->getEnd()   + origin_shift;
			//	h.addGaussLine( line( s,e ), 1.0, 1, 0.01 );
		}


        for(i=0, scene_line_it1=scene_lines->begin();
	    i< getNumScenePGHs(); i++, scene_line_it1++)
		{
	    	// don't repeat or self-compare
	    	if (i>=j)	continue;
	    	line_ptr scene_line1 = *scene_line_it1;
	    	line_ptr scene_line2 = *scene_line_it2;

	    	if (match_array[i].best_match > pgh_match_thresh &&
			match_array[j].best_match > pgh_match_thresh    )
	    	{
				// if both lines are `good' then continue
				// check the angles between the lines in the image and
				// between the lines in the model

				//^^^ FINISH THIS OFF ^^^
				angle 	model_angle, scene_angle;
				double		diff;

				model_angle = match_array[i].object_line->getAngle( *match_array[j].object_line );
				scene_angle = scene_line1->getAngle( *scene_line2 );

				// !!! JUST A HACK, PLAIN AND TRUE: should really calclute the errros in the
				// orientation of each line...
				diff = (double) scene_angle - model_angle;

				diff = diff/0.0174533;
				if ( (diff>-5 && diff<5) || diff<-175 || diff >175)
		    		;
				else
		    		continue;

				// find the start and end points for both lines
				// there could be up to 4 lines
				int	num_lines=0;
				line_ptr	alllines[4];
				line_ptr scene_line;
				int	match_num;
				int	l=0;

				for(l=0;l<2;l++)
				{
		    		if (l==0){	scene_line = scene_line1;	match_num = i; }
		    		else     {	scene_line = scene_line2;	match_num = j; }

		    		line_ptr model_line;
		    		Vector mid_point(2), smid_point(2), unit_scene_line(2),
                 start(2), end(2);
		    		angle	a;
		    		int		acount;
		    		double	l;

               model_line = match_array[match_num].object_line;

		    		//(1) find the angle (in 360 space) from the model line to the scene line
		    		//a = scene_line->angle( model_line );
		    		a = model_line->getAngle( *scene_line );

		    		for(acount=0;acount<2;acount++, a+=M_PI)
		    		{
						//(for most pgh types we'll have to make two entries 180' appart

		        		//(2) find the centre of the model_line
						mid_point = model_line->findMidPoint();

		        		//(3) rotate the vector according to the angle
						mid_point = rotate( mid_point, -a );

						//(4) find the mid point of the scene line
						smid_point= scene_line->findMidPoint();

		        		//(5) move back to the centroid
						smid_point = smid_point - mid_point;

						//(6) now draw a line in the hough space, parallel to the scene line
						//which is centred on this point and which has length
						// = 2*modellinelen+scenelinelen
						unit_scene_line = unit( scene_line->getVector() );
						l = (2* model_line->length() + scene_line->length() ) /2.0;

						Vector temp( unit_scene_line *l );
						start = smid_point - temp;
						end   = smid_point + temp;

						//move the image co-ordinates to the hough co-ordinates.
						//(@ could add a scale change here in future )
						start = start + origin_shift;
						end   = end + origin_shift;

						//we should calculate the weight accuracy and precision required for the
						//line in the hough, but for now we'll hack it! WARNING @
						alllines[num_lines++] =
                    line_ptr( new line( start, end ) );

						//(7) if we're not using directed histograms, repeat the above with
						//180 degrees added to the angle a.
						if (getPghType() == pgh_type_directed)
							break;
		    		}
				}


				//ok we should have either 2 or 4 lines now. we need to extract any
				//intersection points and plot them on the hough
				//contents of the hough won't be as subtle as with the long lines method
				int	a,b;

				for(b=0;b<num_lines;b++)
				{
		    		for(a=0;a<num_lines;a++)
		    		{
						if (a>=b)	continue;

						//do lines alllines[a] and alllines[b] intersect?
						Vector itsct(2);
						bool		t1,t2;

						itsct = alllines[a]->getIntersection( *alllines[b], &t1, &t2 );

						if (t1 && t2)
						{
			    			//they do so plot the point
			    			h.addGaussPoint( itsct, 1.0, 3.0, 0.01 );

			    			//! calculating sigma correctly here would definatley improve
			    			//! things
						}
		    		}
				}

				// for(a=0;a<num_lines;a++)	delete alllines[a];

	    	}//if match is good for both
		} //for line1
    } //for line2


    // we shouldn't normalise this hough because we'll throw away info about the
    // `real' likelihoods for when there are more than one object instance in the image

    // ALGO:
    // so here's the problem right now: what constitutes a well located object? the
    // number of entries which are summed at the possible centroid position will depend
    // upon the *NUmber of lines in the object model* . Which is strange because
    // simplistically it means that we'll always be more `likely' to locate objects such
    // as octagons in the image in preference to rectangles -> their centroids will be
    // represented in the plots with larger peaks.

    // actually pairwise is really quite poor at locating object instances!!

    // anyway! we can weight the histogram entries based on the number of lines in the
    // model. if there were , for example 4 lines in the model, then the centroid, in the
    // best possible case would have a peak value of 4.0. So peaks of value 4.0 indicate
    // well located instances.

    // we might be able to do some clever things with the orientation calcualtion
    // to remove peaks which are rubbish.

    //so ! (A) -> non-maxima suppression
    int	x,y;

#ifdef PROFILE
    double	profile_dt;
    struct timeval	profile_start,profile_end;

    (void) gettimeofday( &profile_start, NULL );
#endif

    //h.display();
    //h.scale(0.0, 1.0);
    double maxval = max_val( h );

#ifdef PROFILE
    (void) gettimeofday( &profile_end, NULL );
    profile_dt = profile_end.tv_sec - profile_start.tv_sec;
    profile_dt+= ((double)(profile_end.tv_usec - profile_start.tv_usec) /1000000 );

    cout <<"STEP 1= " << profile_dt << endl;
    (void) gettimeofday( &profile_start, NULL );
#endif

    thresholdIt( h, hough_peak_thresh * maxval ); // threshold 'good' peaks!!

#ifdef PROFILE
    (void) gettimeofday( &profile_end, NULL );
    profile_dt = profile_end.tv_sec - profile_start.tv_sec;
    profile_dt+= ((double)(profile_end.tv_usec - profile_start.tv_usec) /1000000 );

    cout <<"STEP 2= " << profile_dt << endl;
    (void) gettimeofday( &profile_start, NULL );
#endif

//    h.scale(0.0, 255.0);

#ifdef PROFILE
    (void) gettimeofday( &profile_end, NULL );
    profile_dt = profile_end.tv_sec - profile_start.tv_sec;
    profile_dt+= ((double)(profile_end.tv_usec - profile_start.tv_usec) /1000000 );

    cout <<"STEP 3= " << profile_dt << endl;
    (void) gettimeofday( &profile_start, NULL );
#endif

    hough_transform	newh;

    newh.init( h.getWidth(), h.getHeight() );

#ifdef PROFILE
    (void) gettimeofday( &profile_end, NULL );
    profile_dt = profile_end.tv_sec - profile_start.tv_sec;
    profile_dt+= ((double)(profile_end.tv_usec - profile_start.tv_usec) /1000000 );

    cout <<"STEP 4= " << profile_dt << endl;
    (void) gettimeofday( &profile_start, NULL );
#endif


    //peak enhancement
    //(should use a convolution , but i haven't written it yet!)
    double v;
    for(y=1;y<h.getHeight()-1; y++)
    {
		for(x=1;x<h.getWidth()-1;x++)
		{
	    	v = h.pixel(x,y);
	    	if (  //v>=h.pixel(x-1, y-1) &&
		 			v>=h.pixel(x, y-1) &&
				 // v>=h.pixel(x+1, y-1) &&
		 			v>=h.pixel(x-1, y) &&
		 			v>=h.pixel(x+1, y) &&
				 // v>=h.pixel(x-1, y+1) &&
		 			v>=h.pixel(x, y+1)
		 		 //v>=h.pixel(x+1, y+1)
		 		)
           newh.pixel(x,y) = v;
		}
    }


#ifdef PROFILE
    (void) gettimeofday( &profile_end, NULL );
    profile_dt = profile_end.tv_sec - profile_start.tv_sec;
    profile_dt+= ((double)(profile_end.tv_usec - profile_start.tv_usec) /1000000 );

    cout <<"STEP 5= " << profile_dt << endl;
    (void) gettimeofday( &profile_start, NULL );
#endif


    //store the remaining points as vectors and return the lists
    object_instance_list_ptr retval( new object_instance_list );
    retval->setObject(ob);
    for(y=0;y<newh.getHeight(); y++)
    {
		for(x=0;x<newh.getWidth();x++)
		{
	    	if (newh.pixel(x,y)!=0)
	    	{
           coordinate_xform_ptr o( new coordinate_xform );
           Vector displacement( 2 );
           displacement(0) = x - object_size;
           displacement(1) = y - object_size;

				o->setDisplacement( displacement );
				retval->push_back(o);

				int	i,j;

				//blank the neighbourhood in case its a blurry point
				for(j=y-2;j<=y+2;j++)
				{
		    		for(i=x-1;i<=x+2;i++)
						newh.setPixel(i,j,0);
				}
	    	}
		}
    }

    return retval;
}


//insert locate using points here:-

/**
 * once the object has been located in the scene, this method is used to estimate the orientation of the
 * found instances.
 */
angle pgh_scene::orientObject( scene_match_score_array match_array ,
			      pgh_2dobject &ob, const Vector &loc )
{
    //chuff knows how we do this. i'm not going to use the trad tina way because
    //( i think ) this makes an entry for each line in the image which is daft.

    //algorithm here: repeat the process as for locate using long lines.
    //but don't allocate the location histogram. instead allocate a small angle
    //(1d) histogram. make entries to this for all the lines which pass through
    // `loc` and ignore all others.

    //the code here is a direct copy thinned down from locate_using long lines
    //so one could probably do something clever to remove the repitition.
    int			i;
    int			object_size;
    line_ptr_list_ptr scene_lines;
    Vector origin_shift( 2 );
    line_ptr_list::iterator	scene_line_it;
    hough_transform	angle_hough;
    Vector newloc(2);


    angle_hough.init(360,10);
    if (ob.getWidth() > ob.getHeight()) //allow for rotations of the object
	object_size = ob.getWidth();
    else
	object_size = ob.getHeight();

    newloc(0) = loc(0)+object_size;
    newloc(1) = loc(1)+object_size;
    origin_shift(0) = object_size + centroid_posn_x;
    origin_shift(1) = object_size + centroid_posn_y;

    //a note about the co-ordinates of this hough transform.
    //0,0 on the hough transform corresponds to -object_sizex -object_size on
    //the image plane.
    scene_lines = getListofLines();

    for(i=0, scene_line_it=scene_lines->begin(); i<getNumScenePGHs(); i++, scene_line_it++)
    {
	line_ptr scene_line = *scene_line_it;

	//@there's lots of ways to do this of course. best N etc.
	if (match_array[i].best_match > pgh_match_thresh) //!!WARNING wnats to be a #def really!
	{
	    //make a short lines entry for the time being
	    //the length of the line ( and i'm guessing here ) needs to be
	    //2*the model line length + the scene line length.
	    //if the histogram type isn't directed then we'll need two lines too.

	    //the position of the center of the line on the output histogram is
	    //the position of the centroid.
	    line_ptr	model_line;
	    Vector mid_point(2), smid_point(2), unit_scene_line(2),
         start(2), end(2);
	    angle	a;
	    int		acount;
	    double	l;

	    model_line = match_array[i].object_line;

	    //(1) find the angle (in 360 space) from the model line to the scene line
	    //a = scene_line->angle( model_line );
	    a = model_line->getAngle( *scene_line );

	    for(acount=0;acount<2;acount++, a+=M_PI)
	    {
		//(for most pgh types we'll have to make two entries 180' appart

	        //(2) find the centre of the model_line
		mid_point = model_line->findMidPoint();

	        //(3) rotate the vector according to the angle
		mid_point = rotate( mid_point, -a );

		//(4) find the mid point of the scene line
		smid_point= scene_line->findMidPoint();

	        //(5) move back to the centroid
		smid_point = smid_point - mid_point;

    		//(6) now draw a line in the hough space, parallel to the scene line
		//which is centred on this point and which has length
		// = 2*modellinelen+scenelinelen
		unit_scene_line = unit( scene_line->getVector() );
		l     = (2* model_line->length() + scene_line->length() ) /2.0;

		Vector temp( unit_scene_line *l );
		start = smid_point - temp;
		end   = smid_point + temp;

		//move the image co-ordinates to the hough co-ordinates.
		//(@ could add a scale change here in future )
		start = start + origin_shift;
		end   = end + origin_shift;

		//if the point passes through `loc` then store the angle `a` in
		//the new histogram
		//!! WARNIGN: remove the figure 3!!!

		//!! HACK: shouldn't refernce angle_hough here. but function needs
		//!! an operator. :-(
		if (angle_hough.lineHitsPoint( newloc, line( start, end ), 3, 0.01  ))
		{
		    double sigma;

		    // next line taken from tina:
		    sigma = sqrt( pow( atan( (2.0/(scene_line->length())) ),2.0)
                                    + pow( atan( (2.0/(model_line->length())) ),2.0)
				);
		    angle_hough.makeAngleEntry(  a , sigma, 0.01 );
		}

		//(7) if we're not using directed histograms, repeat the above with
		//180 degrees added to the angle a.
		if (getPghType() == pgh_type_directed)
		    break;
	    }
	}
    }

    //examine the angle hough
    normaliseIt( angle_hough, 0.0, 250.0 );

    //(1) is there a well defined peak ? if no then discard this object instance
    //and throw an exception
    //else
    // return the angle.

    return angle_hough.getAngle();

}

/**
 * update the scene lines. call this function when a new image has arrived (from a camera etc), and
 * has been processed to extract the straight line segments. this method discards previous match
 * information and updates the scene lines.
 */
void	pgh_scene::updateSceneLines( const line_ptr_list &newscene,
                                      int w, int h )
{
    //!FUTURE : delete all the object instace list stuff

    //blank lots of stuff. recalculate the base class pghs
    //need to pass in the camera image size as a parameter even if the
    //lines are extracted elsewhere (for the location hough)
    //(0) store the passed prams
    image_width = w;
    image_height= h;

#ifdef HAVE_GETTIMEOFDAY
    //(1) set the time stamp
    (void)gettimeofday( &timestamp, NULL );
#endif

    //(2) do all the base class histogram creation
    deleteLineInfo();
    createFromLines(newscene, &centroid_posn_x, &centroid_posn_y );

    //(3) allocate space for all the scene line matching
    sms_it	i;

    for(i= match_score_list.begin(); i!=match_score_list.end(); i++)
    {
		// scene_match_score_array s = *i;

		// delete []s;
		*i = scene_match_score_array
        ( new scene_match_score[ getNumScenePGHs() ] );
		// *i = s;
    }

    //(4) that should be that
}


//added by bpa
/**
 * as updateSceneLines above, however this function loads the new scene from .pgm file and then
 * performs the necessary processing before passing it to the updateSceneLines function above.
 */
void	pgh_scene::updateSceneLines( char *newscenePGM, int w, int h )
{
    image<int>	im;
    ifstream file( newscenePGM, ios::binary );
    file >> im;
    updateSceneLines( im );

/*
	line_ptr_list *g = new line_ptr_list;
	Poly_Lines poly_lines;
	line	*l;

	poly_lines.No_Lines = 0;
	poly_lines.Lines = NULL;


	if (pgm2lines(newscenePGM, "",
			canny_sigma, canny_precision, canny_lowthre, canny_upthre, canny_lenthre,
			pgh_angle_sigma,
			roi_lx, roi_ly, roi_ux, roi_uy,
			&poly_lines) != 0)
	{
		mm->Error() << "Lines from scene could not created by pgm2lines()" << endl;
		return;
	}

	for (int Index = 0; Index < poly_lines.No_Lines; Index++)
	{
		l = new line(poly_lines.Lines[Index].pt1.X,
						poly_lines.Lines[Index].pt1.Y,
						poly_lines.Lines[Index].pt2.X,
						poly_lines.Lines[Index].pt2.Y);

		g->push_back(l);
	}

	updateSceneLines( g, w, h );
	LIST_DESTROY( line*, g );

	if (poly_lines.Lines)
	{
		free(poly_lines.Lines);
		poly_lines.Lines = NULL;
	}
*/
}


// added by fbc, 17.12.01
/**
 * as updateSceneLines(1) above, however this function takes a new scene from the give image and then
 * performs the necessary processing before passing it to the updateSceneLines function above.
 */
void	pgh_scene::updateSceneLines( image<int> &imagein )
{
	updateSceneLines( imagein, "" );
}


/**
 * ? updates the scene lines from the given image and also saves the line information to the file name
 * given
 */
void	pgh_scene::updateSceneLines( image<int> &imagein,
                                      char *polyfilename )
{
  line_ptr_list geom;
//	Poly_Lines poly_lines;
	// line	*l;

//	poly_lines.No_Lines = 0;
//	poly_lines.Lines = NULL;

	canny_tool<int>		canny;
	slap_tool			slapper;
	edge_string_ptr_list		edge_strings;

   edge_strings=canny.findEdgeStrings( imagein );
	geom=slapper.findStraightLines( edge_strings );

	updateSceneLines( geom, imagein.getWidth(), imagein.getHeight() );

/*

	if (image2lines(imagein.rawData(), imagein.getWidth(), imagein.getHeight(), polyfilename,
				canny_sigma, canny_precision, canny_lowthre, canny_upthre, canny_lenthre,
				pgh_angle_sigma,
				roi_lx, roi_ly, roi_ux, roi_uy,
				&poly_lines) != 0)
	{
		mm->Error() << "Lines from scene could not created by image2lines()" << endl;
		return;
	}


	for (int Index = 0; Index < poly_lines.No_Lines; Index++)
	{
		l = new line(poly_lines.Lines[Index].pt1.X,
						poly_lines.Lines[Index].pt1.Y,
						poly_lines.Lines[Index].pt2.X,
						poly_lines.Lines[Index].pt2.Y);

		g->push_back(l);
	}

	updateSceneLines( g, imagein.getWidth(), imagein.getHeight() );
	LIST_DESTROY( line*, g );

	if (poly_lines.Lines)
	{
		free(poly_lines.Lines);
		poly_lines.Lines = NULL;
	}
*/
}


/**
 * returns the number of pghs created from the scene.
 */
int		pgh_scene::getNumScenePGHs(void)
{
    return getNumPghs();
}

/**
 * returns a list of the histograms created from the list
 */
pgh_ptr_list	*pgh_scene::getScenePghList(void)
{
    return getPghList();
}


#ifdef HAVE_XALAN
/**
 * save the scene parameters to the filename given. file format is XML
 */
void pgh_scene::saveSceneParameters( const char *fileName )
{
   ofstream ostream( fileName );

	ostream << "<?xml version=\"1.0\"?>" << endl
			<< "<!DOCTYPE scene_parameters SYSTEM \"scene_parameters.dtd\">"
			<< endl
			<< "<scene_parameters prefiltering=\"" << (int)prefiltering << "\" "
			<< "pgh_match_thresh=\"" << pgh_match_thresh << "\" "
			<< "hough_peak_thresh=\"" << hough_peak_thresh << "\">" << endl;
	ostream << "<pgh_recognition_parameters>" << endl;

	storeObjectParams( ostream );
	ostream << "</pgh_recognition_parameters>" << endl
		<< "</scene_parameters>" << endl;
   MMERROR( ostream, mimasexception, ,
            "Error saving parameters to file \"" << fileName << "\"" );
}

/**
 *load the scene parameters from the filename given.
 */
void pgh_scene::loadSceneParameters( const char *fileName )
{
  xml_document domDocument( "" );
  domDocument.load( fileName );
  // Removed check on node-name (must be "scene_parameters").
  // XSD-file to be provided.
  xml_reference< XalanElement > docElement
    ( domDocument.getDocumentElement() );

  if ( docElement.existNode( "@prefiltering" ) )
    prefiltering = atoi( docElement.selectNode( "@prefiltering" ).
                         getNodeText().c_str() ) != 0;

  hough_peak_thresh = atof( docElement.selectNode( "@hough_peak_thresh" ).
                            getNodeText().c_str() );

  pgh_match_thresh = atof( docElement.selectNode( "@pgh_match_thresh" ).
                           getNodeText().c_str() );
					
  extractObjectParams( docElement );
}
#endif

}
