/*
* default values for the static values defined in POL.h
* part of the pairsoflines tool .
*
*
* @author Stuart Meikle (mimas@stumeikle.com)
* @date Mon 28 Oct 2002 08:56:14 CET
* $Header: /cvs/mimas2/lib/pol.cc,v 1.1.1.1 2005/08/09 15:37:29 engmb Exp $
*/


//
// static defs
// stumeikle Mon 28 Oct 2002 08:56:14 CET
//


#include "pol.h"

namespace mimas {
/** Constants for the pairsoflines. Essentially fixed by the quality
 * of the measurement system ( ie camera , but also canny process etc )
 * used by *both* pol_model and pol_scene
 */
 
/** number of angle bins used. more bins means more discriminability (could be good
 *  or bad). more bins means faster recognition too. value is significantly related
 *  to pol::min_len. essentially num_abins=(int) 2PI/(atan(1/min_len)). 
 */
int		pol::num_abins=64; //64
/** minimum line length we should consider from an image. see comment for
 * num_abins above.
 */
double		pol::min_len=3.0; //3.0
/** accuracy which the lenght of lines in the image can be measured.
 *  ** FIX ** really this depends on the length of the line in the first place
 */
double		pol::len_error=2.0; //2.5
/** parallel lines are no good for recognition with this algo because we need the
 *  intersection point of the lines and that's infinitely far with parallel lines.
 *  Hence set sensible limits for the possible angles between the lines
 */
double		pol::min_angle_diff=(30*0.0174533);
double		pol::max_angle_diff=(150*0.0174533);
/** The range of scales we are interested in looking for with scale invariance 
 *  switched on. If you change these values you'll have to change the threshold
 *  modifier in pol_locator_scene.h too. 
 */
double		pol::min_scale=0.5;
double		pol::max_scale=1.5;

}
