#include "string_el.h"
#include "property_image.h"

using namespace boost;
using namespace std;

namespace mimas {

void string_el::edgeSetConns( property_image& esim, int x, int y, 
                                 string_el_ptr_list& junc_list,
                                 string_el_ptr_list& term_list )
{
  int	n=0,w=0,s=0,e=0;
  int	count=0;
	    
  if (!(flags & EDGE_GET_CONN_MASK))
    return;

  //empty the lists
  conn_list.clear();
  conn_c1.reset(); conn_c2.reset();

  string_el_ptr sd;
		
  //create a list of all edgels which have at least one neighbour
  //check the 8 compass directions for other (edgels) and process accordingly
  if ( ( sd = dynamic_pointer_cast< string_el >
              ( esim.getPixel( x - 1, y ) ) ) != NULL &&
       sd->flags & EDGE_GET_CONN_MASK )
    {
      n = 1;
      conn_list.push_back( sd );
      count++;
    }
  if ( ( sd = dynamic_pointer_cast< string_el >
             ( esim.getPixel( x + 1, y ) ) ) != NULL &&
       sd->flags & EDGE_GET_CONN_MASK )
    {
      s = 1;
      conn_list.push_back( sd );
      count++;
    }
  if ( ( sd = dynamic_pointer_cast< string_el >
              ( esim.getPixel( x, y - 1 ) ) ) != NULL &&
       sd->flags & EDGE_GET_CONN_MASK )
    {
      e = 1;
      conn_list.push_back(sd);
      count++;
    }
  if ( ( sd = dynamic_pointer_cast< string_el >
              ( esim.getPixel( x, y + 1 ) ) ) != NULL &&
       sd->flags & EDGE_GET_CONN_MASK )
    {
      w = 1;
      conn_list.push_back(sd);
      count++;
    }

  if ( !n && !w &&
       ( sd = dynamic_pointer_cast< string_el >
              ( esim.getPixel( x - 1, y + 1 ) ) ) != NULL 
       && sd->flags & EDGE_GET_CONN_MASK )
    {
      conn_list.push_back(sd);
      count++;
    }
  if (!n && !e &&
      ( sd = dynamic_pointer_cast< string_el >
        ( esim.getPixel(x - 1, y - 1 ) ) ) != NULL 
      && sd->flags & EDGE_GET_CONN_MASK)
    {
      conn_list.push_back(sd);
      count++;
    }
  if (!s && !w &&
      ( sd = dynamic_pointer_cast< string_el >
        ( esim.getPixel( x + 1, y + 1 ) ) ) != NULL 
      && sd->flags & EDGE_GET_CONN_MASK)
    {
      conn_list.push_back(sd);
      count++;
    }
  if (!s && !e &&
      ( sd = dynamic_pointer_cast< string_el >
        ( esim.getPixel( x + 1, y - 1 ) ) ) != NULL 
      && sd->flags & EDGE_GET_CONN_MASK)
    {
      conn_list.push_back(sd);
      count++;
    }

  list< weak_ptr< string_el > >::iterator i;
		
  switch(count)
    {
    case 0:    	break;
    case 1:	// termination point: add to termination list
      term_list.push_back( dynamic_pointer_cast< string_el >
                           ( esim.getPixel(x,y) ) );
      break;
    case 2:	//
      i = conn_list.begin();
      conn_c1 = (*i);		i++;
      conn_c2 = (*i);
      conn_list.clear();
      break;
    default:	// potential junction: add to junction list
      junc_list.push_back( dynamic_pointer_cast< string_el >
                           ( esim.getPixel(x,y) ) );
      break;
    } //end switch
}

}
