#include "timer.h"

namespace mimas {

double timer::elapsed(void) const
{
#ifdef HAVE_GETTIMEOFDAY
  struct timeval actualTime;
  gettimeofday( &actualTime, NULL );

  // Use timersub-define, which does overflow-handling.
  struct timeval difference;
  timersub( &actualTime, &time, &difference );

  return difference.tv_sec + difference.tv_usec * 1.0E-6;
#else
  assert( false );
  return 0;
#endif
}

}
